package DangerosHTMLtags;

use strict;
use vars qw(@ISA @EXPORT @EXPORT_OK %EXPORT_TAGS $VERSION %ENV);
use Exporter;
$VERSION = 1.00;
@ISA = qw(Exporter);
@EXPORT = qw();

use Data::Dump qw(dump);

use HTML::Parser;

sub new
{
    my ($that,$config,$filters)  = @_;
    my $class = ref($that) || $that;
                                                                                                                                               
    my $self =
    {
        CONFIG		=>	$config,
        FILTERS		=>	$filters,
        HTML		=>	HTML::Parser->new(),
    };

    bless($self, $class);
    return $self;
}

sub DESTROY
{
}

sub check_part
{
    my ($self,$file,$logs) = @_;

    return undef unless 
    (
      (
        ($self->{HEADER}->{'content-type'} =~ /html/ig)
        &&
        ($file->{TYPE} eq 'BODY')
      )
      || 
      (
        ($file->{MAIL_NAME} =~ /html/ig)
        &&
        ($file->{TYPE} eq 'ATTACH')
      )
    );

    my @accum = ();

    $self->{HTML}->handler(start =>  \@accum, '"S", tag, attr');

    return undef unless ($self->{HTML}->parse_file($file->{SYS_NAME}));

    my ($score_OBJECTdata,$score_IFRAMEsrc) = (0,0);

    foreach my $elem (@accum)
    {
        my $tag = $elem->[1];
        my $attrs = $elem->[2];
        foreach my $attr_name (keys %{$attrs})
        {
	    # DATA tag checking
	    $score_OBJECTdata++ if (($attr_name =~ /data/gi) && ($tag =~ /object/gi));
	    # IFrame tag checking
	    $score_IFRAMEsrc++ if (($attr_name =~ /src/gi) && ($tag =~ /iframe/gi));
	};
    };
    
    return undef if (($score_IFRAMEsrc == 0)&&($score_OBJECTdata == 0));

    unless($score_IFRAMEsrc == 0)
    {
        my %log = 
        (
	    'FILTER'	=>	__PACKAGE__,
	    'SCORE'	=>	$score_IFRAMEsrc*$self->{CONFIG}->{SCORE},
	    'COMMENT'	=>	'<IFRAME src=XXX>:' . $file->{MAIL_NAME},
	);
	push(@{$logs},\%log);
    };

    unless($score_OBJECTdata == 0)
    {
        my %log = 
        (
	    'FILTER'	=>	__PACKAGE__,
	    'SCORE'	=>	$score_OBJECTdata*$self->{CONFIG}->{SCORE},
	    'COMMENT'	=>	'<OBJECT data=XXX>:' . $file->{MAIL_NAME},
	);
	push(@{$logs},\%log);
    };

    return ($score_IFRAMEsrc + $score_OBJECTdata);
};

sub check_header
{
    my ($self,$header,$mailbox,$logs) = @_;
    $self->{HEADER} = $header;
    return undef;
};

1;
