package Win32Executable;

use strict;
use vars qw(@ISA @EXPORT @EXPORT_OK %EXPORT_TAGS $VERSION %ENV);
use Exporter;
$VERSION = 1.00;
@ISA = qw(Exporter);
@EXPORT = qw();

use Data::Dump qw(dump);

sub new
{
    my ($that,$config,$filters)  = @_;
    my $class = ref($that) || $that;
                                                                                                                                               
    my $self =
    {
        CONFIG		=>	$config,
        FILTERS		=>	$filters,
    };

    bless($self, $class);
    return $self;
}

sub DESTROY
{
}

sub check_part
{
    my ($self,$file,$logs) = @_;

    return undef if($file->{TYPE} ne 'ATTACH');

    my $score = 0;
    
    my $file_header;
    open(FILE,"< $file->{SYS_NAME}") or return undef;
    read(FILE,$file_header,$self->{CONFIG}->{MAX}) or return undef;
    close(FILE); 
    
    $score++ if grep ($file_header =~ /^$_/i, @{$self->{CONFIG}->{LIST}} );

    return undef if ($score == 0);
    
    my %log = 
    (
	'FILTER'	=>	__PACKAGE__,
	'SCORE'		=>	$score*$self->{CONFIG}->{SCORE},
	'COMMENT'	=>	$file->{MAIL_NAME},
    );
    push(@{$logs},\%log);
    
    return $log{SCORE};
};

sub check_header
{
    return undef;
};

1;
