package ZIPList;

use strict;
use vars qw(@ISA @EXPORT @EXPORT_OK %EXPORT_TAGS $VERSION %ENV);
use Exporter;
$VERSION = 1.00;
@ISA = qw(Exporter);
@EXPORT = qw();

use Archive::Zip qw( :ERROR_CODES :CONSTANTS );
use Data::Dump qw(dump);

Archive::Zip::setErrorHandler( \&ZipErrorHandler );
sub ZipErrorHandler
{
};

sub new
{
    my ($that,$config,$filters)  = @_;
    my $class = ref($that) || $that;
                                                                                                                                               
    my $self =
    {
        CONFIG		=>	$config,
        FILTERS		=>	$filters,
        ZIP		=>	Archive::Zip->new(),
    };

    bless($self, $class);
    return $self;
}

sub DESTROY
{
}

sub check_part
{
    my ($self,$file,$logs) = @_;

#    warn "check_path@" . __PACKAGE__;

    return undef if($file->{TYPE} ne 'ATTACH');

    my $score = 0;

    return undef if ($self->{ZIP}->read( $file->{SYS_NAME} ) != AZ_OK);

    foreach my $member ($self->{ZIP}->memberNames())
    {

#        warn "check_path\@" . __PACKAGE__ . "\@$member";

        my %FILE = 
        (
            MAIL_NAME	=>    'ziparchive|' . $file->{MAIL_NAME} . '/' . $member,
            TYPE	=>    'ATTACH',
        );
        
        my $filter = $self->{FILTERS}->{ForbiddenExtensions};

        $score += $filter->check_part(\%FILE,$logs) if defined($filter);
    };
        
    return undef if ($score == 0);
    
    my %log = 
    (
	'FILTER'	=>	__PACKAGE__,
	'SCORE'		=>	$score*$self->{CONFIG}->{SCORE},
	'COMMENT'	=>	$file->{MAIL_NAME},
    );
    push(@{$logs},\%log);
    
    return $log{SCORE};
};

sub check_header
{
    return undef;
};

1;
